import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JTabbedPane;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JButton;
import javax.swing.LayoutStyle.ComponentPlacement;

import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JPanel;
import javax.swing.JTextPane;

import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Color;
import java.awt.Toolkit;

import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import java.awt.Rectangle;
import java.awt.Point;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.io.File;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.Arrays;
import java.util.Locale;
import java.util.Vector;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JProgressBar;

import org.seamcat.model.plugin.ScenarioInfo;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import javax.swing.border.TitledBorder;
import javax.swing.JFileChooser;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import java.awt.ComponentOrientation;
import javax.swing.JTextField;
import javax.swing.JCheckBox;

/**
 * 
 * @author Karl Koch, karl.koch@bnetza.de
 * @version <strong>For presentation to the SEAMCAT workshop June 2013</strong>
 *
 */
public class BridgeToPostLoadDataR3 extends ShowCollectedData {

	public ScenarioInfo scenario;
	private JFrame frmSimulationResultsCollected;
	private JTabbedPane tabbedPane;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private final ButtonGroup buttonGroup_1 = new ButtonGroup();
	private JFileChooser rFileChooser;
	public JRadioButton rdbtnEBU;
	public JRadioButton rdbtnLocationDRSS;
	public JRadioButton rdbtnDrss;
	private JRadioButton rdbtnCIN;
	private JRadioButton rdbtnCI;
	private JRadioButton rdbtnUnwanted;
	private JRadioButton rdbtnBlocking;
	private boolean useBlocking = false;
	private boolean useUnwanted = true;

	private double rCoverIplusN; // in dB
	private double rCoverI;
	private double rIoverN;
	private double simulationRadius; // in km
	private double locationProbability; // in %
	private int numberOfPixelsBelowLP;
	private int numberOfPixelsInterfered;
	private int numberOfEventsToBeConsidered;
	private boolean useEBU = true;
	private Vector<Double> rLP; // collects the calculated location probabilities
	private double minDRSS;// dRSS required for LP = 95%
	private double STDDEV; // standard deviation
	private double noiseFloor;
	private double blockingResponse;
	private Vector<CollectedDataUnwantedAndBlocking> simulatedResults; // collects all singleResult
	private CollectedDataUnwantedAndBlocking singleResult = new CollectedDataUnwantedAndBlocking();
	private DecimalFormat df = new DecimalFormat();
	private double maxDistance;
	private String resultMessageUnwanted = " "; // to avoid null pointer exceptions
	private String resultMessageBlocking = " ";
	private JTextPane textPaneBlocking;
	private JTextPane textPaneUnwanted;
	private JComboBox comboBoxUnwanted;
	private JComboBox comboBoxBlocking;
	private boolean initialized = false;
	private double radiusScaled;
	private int criterionIndex; // // default C/(I+N)
	private JFileChooser fileChooser;
	private File rCurrentDirectory;
	private boolean fileLoaded = false;
	private JProgressBar progressBarLoad;
	private JTabbedPane tabbedPane_1;
	private int numberOfInterferingLinks;
	private String propagationModel = "";
	private JPanel jp_control;
	private JTextField textFieldModel;
	private JTextField textFieldDistance;
	private JTextField textFieldMinDRSS;
	private JTextField textFieldCI;
	private JTextField textFieldCIN;
	private JTextField textFieldIN;
	private JTextField textFieldSTDDEV;
	private JTextField textFieldLP;
	private JLabel lblNewLabelFileName;
	private boolean isNewFormat = false;
	private JRadioButton rdbtnEBU_1;
	private JButton btnApplyChanges;
	private JCheckBox chckbxDistributionOnly;
	private JRadioButton rdbtnLocationDRSS_1;
	private JRadioButton rdbtnDrss_1;
	private JCheckBox chckbxColorPattern;
	private JPanel panelNotDRSS;
	private JPanel jp_draw;
	private JRadioButton rdbtnCI_1;
	private JRadioButton rdbtnCIN_1;
	private JTextField textFieldNoiseFloor;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					BridgeToPostLoadDataR3 window = new BridgeToPostLoadDataR3();
					window.frmSimulationResultsCollected.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public BridgeToPostLoadDataR3() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	@SuppressWarnings({ "unchecked", "rawtypes" })
	private void initialize() {
		frmSimulationResultsCollected = new JFrame();
		frmSimulationResultsCollected.setTitle("Simulation results collected");
		frmSimulationResultsCollected.setLocation(new Point(620, 250));
		frmSimulationResultsCollected.setBounds(new Rectangle(620, 250, 650, 450));
		//	frame.setBounds(100, 100, 700, 450);
		frmSimulationResultsCollected.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		tabbedPane_1 = new JTabbedPane(JTabbedPane.TOP);
		tabbedPane_1.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {

				if (getRdbtnEBU_1() != null && getRdbtnEBU_1().isSelected())
					useEBU = true;
				if (getRdbtnEBU_1() != null && !getRdbtnEBU_1().isSelected())
					useEBU = false;
				if (getProgressBarLoad() != null)
					getProgressBarLoad().setVisible(false);
				switch (tabbedPane_1.getSelectedIndex()) {
					case 0:
						calculateUnwanted(tabbedPane_1.getComponent(tabbedPane_1.getSelectedIndex()));
						break;
					case 1:
						calculateBlocking(tabbedPane_1.getComponent(tabbedPane_1.getSelectedIndex()));
						break;
					case 2: // figures	
						getChckbxColorPattern().setEnabled(false);
						getChckbxDistributionOnly().setEnabled(false);
						getJp_draw().repaint();
						drawFigures();
						break;
					case 3: {
						if (getProgressBarLoad() != null) {
							getProgressBarLoad().setValue(0);
							getProgressBarLoad().setVisible(false);
						}
						if (rCurrentDirectory != null)
							getFileChooser().setCurrentDirectory(rCurrentDirectory);
					}
						break;
				}
			}

		});

		JButton btnCloseWindow = new JButton("close window");
		btnCloseWindow.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				frmSimulationResultsCollected.dispose();
			}
		});

		progressBarLoad = new JProgressBar();
		progressBarLoad.setEnabled(false);
		progressBarLoad.setForeground(new Color(154, 205, 50));
		progressBarLoad.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		progressBarLoad.setStringPainted(true);
		GroupLayout groupLayout = new GroupLayout(frmSimulationResultsCollected.getContentPane());
		groupLayout
				.setHorizontalGroup(groupLayout.createParallelGroup(Alignment.LEADING).addGroup(
						Alignment.TRAILING,
						groupLayout.createSequentialGroup().addGap(23).addComponent(progressBarLoad,
								GroupLayout.PREFERRED_SIZE, 267, GroupLayout.PREFERRED_SIZE).addPreferredGap(
								ComponentPlacement.RELATED, 130, Short.MAX_VALUE).addComponent(btnCloseWindow).addGap(
								127)).addGroup(
						groupLayout.createSequentialGroup().addComponent(tabbedPane_1, GroupLayout.PREFERRED_SIZE, 632,
								GroupLayout.PREFERRED_SIZE).addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)));
		groupLayout.setVerticalGroup(groupLayout.createParallelGroup(Alignment.LEADING).addGroup(
				groupLayout.createSequentialGroup().addComponent(tabbedPane_1, GroupLayout.PREFERRED_SIZE, 370,
						Short.MAX_VALUE).addPreferredGap(ComponentPlacement.UNRELATED).addGroup(
						groupLayout.createParallelGroup(Alignment.LEADING).addComponent(btnCloseWindow).addComponent(
								progressBarLoad, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE,
								GroupLayout.PREFERRED_SIZE)).addGap(12)));

		JPanel jp_unwanted = new JPanel();
		tabbedPane_1.addTab("   unwanted   ", null, jp_unwanted, null);

		textPaneUnwanted = new JTextPane();
		textPaneUnwanted.setBackground(new Color(255, 250, 205));
		textPaneUnwanted.setFont(new Font("Verdana", Font.PLAIN, 12));

		//	textPaneUnwanted.setText(getResultMessage());

		JButton btnCopyToClipboard = new JButton("copy to clipboard");
		btnCopyToClipboard.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				StringSelection stringSelection = new StringSelection(getResultMessageUnwanted());
				Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
				clipboard.setContents(stringSelection, stringSelection);
			}
		});

		comboBoxUnwanted = new JComboBox();
		comboBoxUnwanted.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				switch (tabbedPane_1.getSelectedIndex()) {
					case 0:
						calculateUnwanted(tabbedPane_1.getComponent(tabbedPane_1.getSelectedIndex()));
						break;
					case 1:
						calculateBlocking(tabbedPane_1.getComponent(tabbedPane_1.getSelectedIndex()));
						break;
					case 2:
						drawFigures();
						break;
					default:
						calculateUnwanted(tabbedPane_1.getComponent(tabbedPane_1.getSelectedIndex()));
				}
			}
		});

		comboBoxUnwanted.setModel(new DefaultComboBoxModel(new String[] { "C / I", "C / (I + N)", "I / N" }));
		comboBoxUnwanted.setSelectedIndex(1);
		comboBoxUnwanted.setFont(new Font("Verdana", Font.PLAIN, 11));

		JLabel lblInterferenceCriterion = new JLabel("Protection Criterion");
		GroupLayout gl_jp_unwanted = new GroupLayout(jp_unwanted);
		gl_jp_unwanted.setHorizontalGroup(gl_jp_unwanted.createParallelGroup(Alignment.LEADING).addGroup(
				gl_jp_unwanted.createSequentialGroup().addGap(10).addGroup(
						gl_jp_unwanted.createParallelGroup(Alignment.LEADING, false).addComponent(textPaneUnwanted,
								GroupLayout.PREFERRED_SIZE, 607, GroupLayout.PREFERRED_SIZE).addGroup(
								gl_jp_unwanted.createSequentialGroup().addComponent(btnCopyToClipboard,
										GroupLayout.PREFERRED_SIZE, 133, GroupLayout.PREFERRED_SIZE).addPreferredGap(
										ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
										.addComponent(lblInterferenceCriterion).addGap(35).addComponent(
												comboBoxUnwanted, GroupLayout.PREFERRED_SIZE, 101,
												GroupLayout.PREFERRED_SIZE).addGap(49))).addContainerGap(10,
						Short.MAX_VALUE)));
		gl_jp_unwanted.setVerticalGroup(gl_jp_unwanted.createParallelGroup(Alignment.LEADING).addGroup(
				gl_jp_unwanted.createSequentialGroup().addGap(5).addComponent(textPaneUnwanted,
						GroupLayout.PREFERRED_SIZE, 287, GroupLayout.PREFERRED_SIZE).addGap(18).addGroup(
						gl_jp_unwanted.createParallelGroup(Alignment.BASELINE).addComponent(btnCopyToClipboard,
								GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE).addGroup(
								gl_jp_unwanted.createSequentialGroup().addGap(2).addComponent(comboBoxUnwanted))
								.addGroup(
										gl_jp_unwanted.createSequentialGroup().addGap(9).addComponent(
												lblInterferenceCriterion, GroupLayout.DEFAULT_SIZE,
												GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))).addGap(9)));
		jp_unwanted.setLayout(gl_jp_unwanted);

		JPanel jp_block = new JPanel();
		tabbedPane_1.addTab("   blocking   ", null, jp_block, null);

		comboBoxBlocking = new JComboBox();
		comboBoxBlocking.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				switch (tabbedPane_1.getSelectedIndex()) {
					case 0:
						calculateUnwanted(tabbedPane_1.getComponent(tabbedPane_1.getSelectedIndex()));
						break;
					case 1:
						calculateBlocking(tabbedPane_1.getComponent(tabbedPane_1.getSelectedIndex()));
						break;
					case 2:
						drawFigures();
						break;
					default:
						calculateUnwanted(tabbedPane_1.getComponent(tabbedPane_1.getSelectedIndex()));
				}
			}
		});

		comboBoxBlocking.setModel(new DefaultComboBoxModel(new String[] { "C / I", "C / (I + N)", "I / N" }));
		comboBoxBlocking.setSelectedIndex(1);
		comboBoxBlocking.setFont(new Font("Verdana", Font.PLAIN, 11));

		JLabel lblProtectionCriterion = new JLabel("Protection Criterion");

		textPaneBlocking = new JTextPane();
		textPaneBlocking.setFont(new Font("Verdana", Font.PLAIN, 12));
		textPaneBlocking.setBackground(new Color(255, 250, 205));

		JButton button = new JButton("copy to clipboard");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				StringSelection stringSelection = new StringSelection(getResultMessageBlocking());
				Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
				clipboard.setContents(stringSelection, stringSelection);
			}
		});
		GroupLayout gl_jp_block = new GroupLayout(jp_block);
		gl_jp_block.setHorizontalGroup(gl_jp_block.createParallelGroup(Alignment.LEADING).addGap(0, 627,
				Short.MAX_VALUE).addGroup(
				gl_jp_block.createSequentialGroup().addGap(10).addGroup(
						gl_jp_block.createParallelGroup(Alignment.LEADING, false).addComponent(textPaneBlocking,
								GroupLayout.PREFERRED_SIZE, 607, GroupLayout.PREFERRED_SIZE).addGroup(
								gl_jp_block.createSequentialGroup().addComponent(button, GroupLayout.PREFERRED_SIZE,
										133, GroupLayout.PREFERRED_SIZE).addPreferredGap(ComponentPlacement.RELATED,
										GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE).addComponent(lblProtectionCriterion)
										.addGap(35).addComponent(comboBoxBlocking, GroupLayout.PREFERRED_SIZE, 101,
												GroupLayout.PREFERRED_SIZE).addGap(49))).addContainerGap(10,
						Short.MAX_VALUE)));
		gl_jp_block.setVerticalGroup(gl_jp_block.createParallelGroup(Alignment.LEADING).addGap(0, 342, Short.MAX_VALUE)
				.addGroup(
						gl_jp_block.createSequentialGroup().addGap(5).addComponent(textPaneBlocking,
								GroupLayout.PREFERRED_SIZE, 287, GroupLayout.PREFERRED_SIZE).addGap(18).addGroup(
								gl_jp_block.createParallelGroup(Alignment.LEADING).addGroup(
										gl_jp_block.createSequentialGroup().addGap(2).addComponent(comboBoxBlocking))
										.addGroup(
												gl_jp_block.createSequentialGroup().addGap(9).addComponent(
														lblProtectionCriterion, GroupLayout.DEFAULT_SIZE,
														GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)).addGroup(
												gl_jp_block.createParallelGroup(Alignment.BASELINE).addComponent(
														button, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE,
														Short.MAX_VALUE))).addGap(9)));
		jp_block.setLayout(gl_jp_block);

		jp_draw = new JPanel();
		tabbedPane_1.addTab("   figures   ", null, jp_draw, null);

		rdbtnEBU_1 = new JRadioButton("Location Probability (EBU)");
		rdbtnEBU_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (getRdbtnEBU_1().isSelected()) {
					getChckbxColorPattern().setEnabled(false);
					getChckbxDistributionOnly().setEnabled(false);
					getJp_draw().repaint();
				} else {
					getChckbxColorPattern().setEnabled(true);
					getChckbxDistributionOnly().setEnabled(true);
					getJp_draw().repaint();
				}
				if (getRdbtnLocationDRSS_1().isSelected()) {
					if (getRdbtnEBU_1().isSelected()) {
						getChckbxColorPattern().setEnabled(false);
						getChckbxDistributionOnly().setEnabled(false);
						getJp_draw().repaint();
					} else {
						getChckbxColorPattern().setEnabled(true);
						getChckbxDistributionOnly().setEnabled(true);
						getJp_draw().repaint();
					}
				}
			}
		});
		buttonGroup.add(rdbtnEBU_1);
		rdbtnEBU_1.setSelected(true);

		rdbtnLocationDRSS_1 = new JRadioButton("Location Probability (dRSS)");
		rdbtnLocationDRSS_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (getRdbtnLocationDRSS_1().isSelected()) {
					getChckbxColorPattern().setEnabled(false);
					getChckbxDistributionOnly().setEnabled(false);
					getJp_draw().repaint();
				} else {
					getChckbxColorPattern().setEnabled(true);
					getChckbxDistributionOnly().setEnabled(true);
					getJp_draw().repaint();
				}
			}
		});

		buttonGroup.add(rdbtnLocationDRSS_1);

		rdbtnDrss_1 = new JRadioButton("dRSS");
		rdbtnDrss_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(getRdbtnDrss_1().isSelected()){
					getChckbxColorPattern().setEnabled(false);
					getChckbxDistributionOnly().setEnabled(true);
					getJp_draw().repaint();
				} else {
					getChckbxColorPattern().setEnabled(true);
					getChckbxDistributionOnly().setEnabled(true);
					getJp_draw().repaint();
				}
			}
		});

		buttonGroup.add(rdbtnDrss_1);

		rdbtnCIN_1 = new JRadioButton("C / (I + N)");
		rdbtnCIN_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				getChckbxColorPattern().setEnabled(true);
				getChckbxDistributionOnly().setEnabled(true);
				getJp_draw().repaint();
			}
		});

		buttonGroup.add(rdbtnCIN_1);

		rdbtnCI_1 = new JRadioButton("C / I");
		rdbtnCI_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				getChckbxColorPattern().setEnabled(true);
				getChckbxDistributionOnly().setEnabled(true);
				getJp_draw().repaint();
			}
		});

		buttonGroup.add(rdbtnCI_1);

		JButton btnDrawFigure = new JButton("draw figure");
		btnDrawFigure.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				StdDraw.clear();
				drawFigureSelected();
			}

			private void drawFigureSelected() {
				// TODO Auto-generated method stub
				if (rdbtnEBU_1.isSelected()) {
					getChckbxColorPattern().setEnabled(false);
					getPanelNotDRSS().repaint();
					drawLocationEBU();
				} else if (rdbtnLocationDRSS_1.isSelected()) {
					getChckbxColorPattern().setEnabled(false);
					getPanelNotDRSS().repaint();
					drawLocationDRSS();
				} else if (rdbtnDrss_1.isSelected()) {
					drawDistributionDRSS();
				} else if (rdbtnCIN_1.isSelected()) {
					getChckbxColorPattern().setEnabled(true);
					getPanelNotDRSS().repaint();
					drawDistributionCIN();
				} else if (rdbtnCI_1.isSelected()) {
					getChckbxColorPattern().setEnabled(true);
					getPanelNotDRSS().repaint();
					drawDistributionCI();
				}

			}
		});

		panelNotDRSS = new JPanel();
		panelNotDRSS.setBorder(new TitledBorder(null, "  not active when dRSS is selected  ", TitledBorder.LEADING,
				TitledBorder.TOP, null, null));

		chckbxDistributionOnly = new JCheckBox("schow only loaction distribution ");
		chckbxDistributionOnly.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				getFrmSimulationResultsCollected().repaint();
				if (getLblNewLabelFileName().isEnabled()) {// data file loaded
					prepareDataLoaded();
				} else {
					initPlugin();
				}
			}
		});
		GroupLayout gl_jp_draw = new GroupLayout(jp_draw);
		gl_jp_draw.setHorizontalGroup(
			gl_jp_draw.createParallelGroup(Alignment.TRAILING)
				.addGroup(Alignment.LEADING, gl_jp_draw.createSequentialGroup()
					.addGap(153)
					.addGroup(gl_jp_draw.createParallelGroup(Alignment.LEADING)
						.addComponent(rdbtnCIN_1)
						.addComponent(rdbtnDrss_1)
						.addComponent(rdbtnLocationDRSS_1)
						.addComponent(rdbtnCI_1)
						.addComponent(rdbtnEBU_1))
					.addGroup(gl_jp_draw.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_draw.createSequentialGroup()
							.addPreferredGap(ComponentPlacement.RELATED, 106, Short.MAX_VALUE)
							.addGroup(gl_jp_draw.createParallelGroup(Alignment.LEADING)
								.addComponent(chckbxDistributionOnly)
								.addComponent(btnDrawFigure)))
						.addGroup(gl_jp_draw.createSequentialGroup()
							.addGap(56)
							.addComponent(panelNotDRSS, GroupLayout.PREFERRED_SIZE, 243, GroupLayout.PREFERRED_SIZE)))
					.addContainerGap(20, Short.MAX_VALUE))
		);
		gl_jp_draw.setVerticalGroup(
			gl_jp_draw.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_jp_draw.createSequentialGroup()
					.addGroup(gl_jp_draw.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_draw.createSequentialGroup()
							.addGap(54)
							.addComponent(rdbtnEBU_1, GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
							.addGap(18)
							.addComponent(rdbtnLocationDRSS_1, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
							.addGap(18)
							.addComponent(rdbtnDrss_1, GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
							.addGap(18)
							.addComponent(rdbtnCIN_1, GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
							.addGap(18)
							.addComponent(rdbtnCI_1, GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE))
						.addGroup(gl_jp_draw.createSequentialGroup()
							.addContainerGap()
							.addComponent(panelNotDRSS, GroupLayout.PREFERRED_SIZE, 159, Short.MAX_VALUE)
							.addGap(18)))
					.addGap(14)
					.addComponent(chckbxDistributionOnly)
					.addGap(18)
					.addComponent(btnDrawFigure)
					.addGap(23))
		);

		rdbtnBlocking = new JRadioButton("blocking");
		rdbtnBlocking.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				setRadioButtonBlocking();
			}
		});
		buttonGroup_1.add(rdbtnBlocking);

		rdbtnUnwanted = new JRadioButton("unwanted");
		rdbtnUnwanted.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				setRadioButtonUnwanted();
			}
		});

		rdbtnUnwanted.setSelected(true);
		buttonGroup_1.add(rdbtnUnwanted);
		
				chckbxColorPattern = new JCheckBox("switch off color pattern");
				chckbxColorPattern.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						// TODO
						if(getRdbtnDrss_1().isSelected()){
							getChckbxColorPattern().setEnabled(false);
						}else{
							getChckbxColorPattern().setEnabled(true);
						}
						getFrmSimulationResultsCollected().repaint();
					}
				});
		GroupLayout gl_panelNotDRSS = new GroupLayout(panelNotDRSS);
		gl_panelNotDRSS.setHorizontalGroup(
			gl_panelNotDRSS.createParallelGroup(Alignment.LEADING)
				.addGroup(Alignment.TRAILING, gl_panelNotDRSS.createSequentialGroup()
					.addContainerGap(58, Short.MAX_VALUE)
					.addGroup(gl_panelNotDRSS.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_panelNotDRSS.createSequentialGroup()
							.addComponent(rdbtnBlocking, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
							.addContainerGap())
						.addGroup(Alignment.TRAILING, gl_panelNotDRSS.createSequentialGroup()
							.addGroup(gl_panelNotDRSS.createParallelGroup(Alignment.LEADING)
								.addComponent(rdbtnUnwanted)
								.addComponent(chckbxColorPattern))
							.addGap(32))))
		);
		gl_panelNotDRSS.setVerticalGroup(
			gl_panelNotDRSS.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panelNotDRSS.createSequentialGroup()
					.addGap(19)
					.addComponent(rdbtnUnwanted)
					.addGap(18)
					.addComponent(rdbtnBlocking, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)
					.addGap(26)
					.addComponent(chckbxColorPattern)
					.addGap(31))
		);
		panelNotDRSS.setLayout(gl_panelNotDRSS);
		jp_draw.setLayout(gl_jp_draw);
		setRdbtnEBU(this.rdbtnEBU);
		frmSimulationResultsCollected.getContentPane().setLayout(groupLayout);
		setDefaultTabbedPane(tabbedPane_1);

		JPanel jp_filechooser = new JPanel();
		tabbedPane_1.addTab("   load data   ", null, jp_filechooser, null);

		fileChooser = new JFileChooser();
		fileChooser.setAcceptAllFileFilterUsed(true);
		fileChooser.setFileFilter(new javax.swing.filechooser.FileFilter() {
			public boolean accept(File file) {
				return (file.isDirectory() || file.getName().toLowerCase().endsWith(".xml"));
			}

			public String getDescription() {
				return "eXtensible Markup Language (*.xml)";
			}
		});
		fileChooser.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					handleFileChooser(e);
				} catch (ParserConfigurationException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (SAXException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		});
		fileChooser.setAcceptAllFileFilterUsed(false);
		GroupLayout gl_jp_filechooser = new GroupLayout(jp_filechooser);
		gl_jp_filechooser.setHorizontalGroup(gl_jp_filechooser.createParallelGroup(Alignment.LEADING).addGroup(
				Alignment.TRAILING,
				gl_jp_filechooser.createSequentialGroup().addContainerGap(23, Short.MAX_VALUE).addComponent(
						fileChooser, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addContainerGap()));
		gl_jp_filechooser.setVerticalGroup(gl_jp_filechooser.createParallelGroup(Alignment.LEADING).addGroup(
				gl_jp_filechooser.createSequentialGroup().addContainerGap().addComponent(fileChooser,
						GroupLayout.DEFAULT_SIZE, 320, Short.MAX_VALUE).addContainerGap()));
		jp_filechooser.setLayout(gl_jp_filechooser);

		jp_control = new JPanel();

		tabbedPane_1.addTab("   parameter used   ", null, jp_control, null);

		JLabel lblNewLabel = new JLabel("propagation Model");

		JLabel lblSimulationDistance = new JLabel("simulation distance");

		JLabel lblMindrss = new JLabel("minDRSS");

		JLabel lblCi = new JLabel("C/I");

		JLabel lblCin = new JLabel("C/(I+N)");

		JLabel lblIn = new JLabel("I/N");

		JLabel lblStddev = new JLabel("stdDEV");

		textFieldModel = new JTextField();
		textFieldModel.setColumns(10);

		textFieldDistance = new JTextField();
		textFieldDistance.setColumns(10);

		textFieldMinDRSS = new JTextField();
		textFieldMinDRSS.setColumns(10);

		textFieldCI = new JTextField();
		textFieldCI.setColumns(10);

		textFieldCIN = new JTextField();
		textFieldCIN.setColumns(10);

		textFieldIN = new JTextField();
		textFieldIN.setColumns(10);

		textFieldSTDDEV = new JTextField();
		textFieldSTDDEV.setColumns(10);

		JLabel lblNewLabelLP = new JLabel("location probability");

		textFieldLP = new JTextField();
		textFieldLP.setColumns(10);

		lblNewLabelFileName = new JLabel("New label");
		lblNewLabelFileName.setEnabled(false);
		lblNewLabelFileName.setFont(new Font("Tahoma", Font.BOLD, 11));
		lblNewLabelFileName.setForeground(new Color(0, 0, 255));

		btnApplyChanges = new JButton("apply changes");
		btnApplyChanges.setVisible(false);
		btnApplyChanges.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				applyChangedParamter();
			}
		});
		
		JLabel lblNoiseFloor = new JLabel("noise floor");
		
		textFieldNoiseFloor = new JTextField();
		textFieldNoiseFloor.setColumns(10);
		GroupLayout gl_jp_control = new GroupLayout(jp_control);
		gl_jp_control.setHorizontalGroup(
			gl_jp_control.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_jp_control.createSequentialGroup()
					.addGap(47)
					.addComponent(lblNewLabelFileName))
				.addGroup(gl_jp_control.createSequentialGroup()
					.addGap(47)
					.addComponent(lblNewLabel)
					.addGap(133)
					.addComponent(textFieldModel, GroupLayout.PREFERRED_SIZE, 223, GroupLayout.PREFERRED_SIZE))
				.addGroup(gl_jp_control.createSequentialGroup()
					.addGap(47)
					.addComponent(lblSimulationDistance)
					.addGap(132)
					.addComponent(textFieldDistance, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
				.addGroup(gl_jp_control.createSequentialGroup()
					.addGap(47)
					.addComponent(lblMindrss)
					.addGap(180)
					.addComponent(textFieldMinDRSS, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
				.addGroup(gl_jp_control.createSequentialGroup()
					.addGap(47)
					.addComponent(lblNewLabelLP)
					.addGap(132)
					.addComponent(textFieldLP, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
				.addGroup(gl_jp_control.createSequentialGroup()
					.addGap(47)
					.addComponent(lblCi)
					.addGap(207)
					.addComponent(textFieldCI, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
				.addGroup(gl_jp_control.createSequentialGroup()
					.addGap(47)
					.addComponent(lblCin, GroupLayout.PREFERRED_SIZE, 126, GroupLayout.PREFERRED_SIZE)
					.addGap(96)
					.addComponent(textFieldCIN, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
				.addGroup(Alignment.TRAILING, gl_jp_control.createSequentialGroup()
					.addContainerGap(463, Short.MAX_VALUE)
					.addComponent(btnApplyChanges)
					.addGap(63))
				.addGroup(gl_jp_control.createSequentialGroup()
					.addGap(47)
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addComponent(lblIn)
						.addComponent(lblStddev)
						.addComponent(lblNoiseFloor))
					.addGap(172)
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addComponent(textFieldNoiseFloor, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addComponent(textFieldSTDDEV, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						.addComponent(textFieldIN, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(272))
		);
		gl_jp_control.setVerticalGroup(
			gl_jp_control.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_jp_control.createSequentialGroup()
					.addComponent(lblNewLabelFileName)
					.addGap(5)
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_control.createSequentialGroup()
							.addGap(3)
							.addComponent(lblNewLabel))
						.addComponent(textFieldModel, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(6)
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_control.createSequentialGroup()
							.addGap(3)
							.addComponent(lblSimulationDistance))
						.addComponent(textFieldDistance, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(6)
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_control.createSequentialGroup()
							.addGap(3)
							.addComponent(lblMindrss))
						.addComponent(textFieldMinDRSS, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(11)
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_control.createSequentialGroup()
							.addGap(3)
							.addComponent(lblNewLabelLP))
						.addComponent(textFieldLP, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(11)
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_control.createSequentialGroup()
							.addGap(3)
							.addComponent(lblCi))
						.addComponent(textFieldCI, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(6)
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_control.createSequentialGroup()
							.addGap(3)
							.addComponent(lblCin))
						.addComponent(textFieldCIN, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGap(11)
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_control.createSequentialGroup()
							.addGap(3)
							.addComponent(lblIn))
						.addComponent(textFieldIN, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
						.addGroup(gl_jp_control.createSequentialGroup()
							.addGap(12)
							.addComponent(lblStddev)
							.addGroup(gl_jp_control.createParallelGroup(Alignment.LEADING)
								.addGroup(gl_jp_control.createSequentialGroup()
									.addGap(27)
									.addComponent(btnApplyChanges, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
									.addGap(56))
								.addGroup(gl_jp_control.createSequentialGroup()
									.addPreferredGap(ComponentPlacement.UNRELATED)
									.addComponent(lblNoiseFloor)
									.addContainerGap())))
						.addGroup(gl_jp_control.createSequentialGroup()
							.addPreferredGap(ComponentPlacement.UNRELATED)
							.addComponent(textFieldSTDDEV, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(textFieldNoiseFloor, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addGap(75))))
		);
		jp_control.setLayout(gl_jp_control);

	}

	protected void applyChangedParamter() {
		propagationModel = getTextFieldModel().getText();
		simulationRadius = Double.parseDouble(getTextFieldDistance().getText());
		minDRSS = Double.parseDouble(getTextFieldMinDRSS().getText());
		locationProbability = Double.parseDouble(getTextFieldLP().getText());
		rCoverI = Double.parseDouble(getTextFieldCI().getText());
		rCoverIplusN = Double.parseDouble(getTextFieldCIN().getText());
		rIoverN = Double.parseDouble(getTextFieldIN().getText());
		STDDEV = Double.parseDouble(getTextFieldSTDDEV().getText());

		getTextFieldModel().setText(propagationModel);
		getTextFieldDistance().setText(Double.toString(simulationRadius));
		getTextFieldMinDRSS().setText(Double.toString(minDRSS));
		getTextFieldLP().setText(Double.toString(locationProbability));
		getTextFieldCI().setText(Double.toString(rCoverI));
		getTextFieldCIN().setText(Double.toString(rCoverIplusN));
		getTextFieldIN().setText(Double.toString(rIoverN));
		getTextFieldSTDDEV().setText(Double.toString(STDDEV));

		getTabbedPane().setSelectedIndex(2); // draw figures

	}

	protected File getDefaultPath() {
		return rFileChooser.getCurrentDirectory();
	}

	protected void handleFileChooser(ActionEvent e) throws ParserConfigurationException, SAXException, IOException {
				long starttime = System.currentTimeMillis();
		if (getProgressBarLoad() != null) {
			getProgressBarLoad().setValue(0);
		}
		rFileChooser = getFileChooser();
		setDirectory(rFileChooser.getCurrentDirectory());
		rFileChooser.setCurrentDirectory(fileChooser.getCurrentDirectory());
		if (e.getActionCommand().indexOf("ApproveSelection") != -1) {
			rFileChooser.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
			parseToXML(fileChooser.getSelectedFile());
			prepareDataLoaded();
			getTabbedPane().setSelectedIndex(2); // draw figures
		}
	}

	private void prepareDataLoaded() {
		fileLoaded = true;
		numberOfEventsToBeConsidered = simulatedResults.lastElement().event - simulatedResults.firstElement().event;
		if (simulatedResults.firstElement().simulationRadius > 0) {// to be backwards compatible
			minDRSS = simulatedResults.firstElement().minDRSS;
			rCoverIplusN = simulatedResults.firstElement().cOverN;
			simulationRadius = simulatedResults.firstElement().simulationRadius;
			rCoverI = simulatedResults.firstElement().cOverI;
			rIoverN = simulatedResults.firstElement().cIverN;
			STDDEV = simulatedResults.firstElement().STDDEV;
			noiseFloor = simulatedResults.firstElement().noiseFloor;
			blockingResponse = simulatedResults.firstElement().blockingResponse;
			propagationModel = simulatedResults.firstElement().propagationModel;
			if (propagationModel.equals("NoModelDefined")) {
				propagationModel = "User-defined dRSS";
			}
		}
		maxDistance = getMaxDistance();
		numberOfInterferingLinks = getNumberOfInterferingLinks();
		if (!getChckbxDistributionOnly().isSelected()) {
			calculateLocationProbability(scenario);
			setLP(rLP);
			numberOfPixelsBelowLP = getNumberOfPixelsBelowLP();
		}
		setNumberOfPixelsInterfered(scenario);
		getLblNewLabelFileName().setText(getFileChooser().getSelectedFile().toString());
		if (!isNewFormat()) {
			getLblNewLabelFileName().setForeground(new Color(255, 0, 0));
		} else {
			getLblNewLabelFileName().setForeground(new Color(0, 0, 255));
		}
		getLblNewLabelFileName().setEnabled(true);
		getBtnApplyChanges().setVisible(true);
		setParametToControlTab();
		getFrmSimulationResultsCollected().repaint();
		if (getChckbxDistributionOnly().isSelected()) {
			getRdbtnEBU_1().setEnabled(false);
			getRdbtnLocationDRSS_1().setEnabled(false);
			getRdbtnDrss_1().setSelected(true);
			getChckbxColorPattern().setEnabled(false);
			getFrmSimulationResultsCollected().repaint();
		} else {
			getRdbtnEBU_1().setSelected(true);
			getRdbtnEBU_1().setEnabled(true);
			getRdbtnLocationDRSS_1().setEnabled(true);
			getChckbxColorPattern().setEnabled(false);
			getFrmSimulationResultsCollected().repaint();
		}

	}

	private int getNumberOfInterferingLinks() {
		if (!simulatedResults.firstElement().isMultipleILK)
			return 1;
		int i = 0;
		do {
			i += 1;
		} while (simulatedResults.firstElement().event == simulatedResults.get(i).event);
		return i;
	}

	private double getMaxDistance() {
		double md = 0;
		for (int i = 0; i < simulatedResults.size(); i++) {
			double rmd = Math.sqrt(simulatedResults.get(i).x * simulatedResults.get(i).x + simulatedResults.get(i).y
					* simulatedResults.get(i).y);
			if (rmd > md)
				md = rmd;
		}
		return md;
	}

	private void parseToXML(File selectedFile) throws ParserConfigurationException, SAXException, IOException {
		// TODO Auto-generated method stub
		simulatedResults = new Vector<CollectedDataUnwantedAndBlocking>();
		singleResult = new CollectedDataUnwantedAndBlocking();
		isNewFormat = false; // default for older data files

		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			Document doc = db.parse(selectedFile);
			doc.getDocumentElement().normalize();
//			System.out.println("Root element " + doc.getDocumentElement().getNodeName());
			NodeList nodeLst = doc.getElementsByTagName("event");
//			System.out.println("Information " + nodeLst.getLength());

			for (int s = 0; s < nodeLst.getLength(); s++) {

				Node fstNode = nodeLst.item(s);

				if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
					Element fstElmnt = (Element) fstNode;
					NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("event");
					NamedNodeMap fstNmElmntLst1 = fstElmnt.getAttributes();
					for (int i = 0; i < fstNmElmntLst1.getLength(); i++) {
						String wert = fstNmElmntLst1.item(i).toString();					
						if (wert.indexOf("dRSS") != -1)
							singleResult.dRSS = Double.parseDouble(wert.substring(6, (wert.length() - 2)));
						else if (wert.indexOf("iRSSblock") != -1)
							singleResult.iRSSblock = Double.parseDouble(wert.substring(11, (wert.length() - 2)));
						else if (wert.indexOf("eventNr") != -1)
							singleResult.event = Integer.parseInt(wert.substring(9, (wert.length() - 2)));
						else if (wert.indexOf("iRSSunw") != -1)
							singleResult.iRSS = Double.parseDouble(wert.substring(9, (wert.length() - 2)));
						else if (wert.indexOf("ilk") != -1) {
							//							System.out.println(wert);
							singleResult.ilk = Integer.parseInt(wert.substring(5, (wert.length() - 2)));
						} else if (wert.indexOf("noiseFloor") != -1)
							singleResult.noiseFloor = Double.parseDouble(wert.substring(12, (wert.length() - 2)));
						else if (wert.indexOf("x") != -1)
							singleResult.x = Double.parseDouble(wert.substring(3, (wert.length() - 2)));
						else if (wert.indexOf("y") != -1)
							singleResult.y = Double.parseDouble(wert.substring(3, (wert.length() - 2)));
						else if (wert.indexOf("multiple") != -1) {
							if (wert.indexOf("true") != -1)
								singleResult.isMultipleILK = true;
							else
								singleResult.isMultipleILK = false;
						} else if (wert.indexOf("CoverI") != -1)
							singleResult.cOverI = Double.parseDouble(wert.substring(8, (wert.length() - 2)));
						else if (wert.indexOf("IoverN") != -1)
							singleResult.cIverN = Double.parseDouble(wert.substring(8, (wert.length() - 2)));
						else if (wert.indexOf("CoverNplusI") != -1)
							singleResult.cOverN = Double.parseDouble(wert.substring(13, (wert.length() - 2)));
						else if (wert.indexOf("minDRSS") != -1)
							singleResult.minDRSS = Double.parseDouble(wert.substring(9, (wert.length() - 2)));
						else if (wert.indexOf("simulationRadius") != -1)
							singleResult.simulationRadius = Double.parseDouble(wert.substring(18, (wert.length() - 2)));
						else if (wert.indexOf("model") != -1) {
							singleResult.propagationModel = (wert.substring(7, (wert.length() - 2)));
							isNewFormat = true;
						} else if (wert.indexOf("stdDEV") != -1)
							singleResult.STDDEV = Double.parseDouble(wert.substring(8, (wert.length() - 2)));
						else if (wert.indexOf("blockingResponse") != -1)
							singleResult.blockingResponse = Double.parseDouble(wert.substring(18, (wert.length() - 2)));
					}
				}
				simulatedResults.add(singleResult);
				singleResult = new CollectedDataUnwantedAndBlocking();
			}

		} catch (Exception ex) {
			ex.printStackTrace();
		}

		rFileChooser.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}


	private void setDirectory(File currentDirectory) {
		// TODO Auto-generated method stub
		this.rCurrentDirectory = currentDirectory;
	}

	protected void setRadioButtonUnwanted() {
		// TODO Auto-generated method stub
		this.useBlocking = false;
		this.useUnwanted = true;
	}

	protected void setRadioButtonBlocking() {
		// TODO Auto-generated method stub
		this.useBlocking = true;
		this.useUnwanted = false;
	}

	private void setDefaultTabbedPane(JTabbedPane tabbedPane) {
		// TODO Auto-generated method stub
		tabbedPane.setSelectedIndex(2);
	}

	/**
	 * @return the initialized
	 */
	public boolean isInitialized() {
		return initialized;
	}

	/**
	 * @param initialized
	 *            the initialized to set
	 */
	public void setInitialized(boolean initialized) {
		this.initialized = initialized;
	}

	/**
	 * @param rdbtnEBU
	 *            the rdbtnEBU to set
	 */
	public void setRdbtnEBU(JRadioButton rdbtnEBU) {
		this.rdbtnEBU = rdbtnEBU;
	}

	protected void drawDistributionCI() {
		// TODO Auto-generated method stub
		if(getRdbtnUnwanted().isSelected())useUnwanted = true;
		else useUnwanted = false;
		calculateCI();
		drawCoverIColored(scenario);
	}

	/**
	 * {@literal shows a colour scaled distribution of C/I}
	 * 
	 * @param scenario
	 */
	private void drawCoverIColored(ScenarioInfo scenario) {
		getChckbxColorPattern().setEnabled(true);
		scaleFigure();
		double correctionFactor = getRadiusScaled() / getSimulationRadius() / 2;
		correctionFactor = 1;
		double highestCoverI = getHighestCoverI();
		double lowestCoverI = getLowestCoverI();
		double tCoverI = 0;
		double range = Math.abs(highestCoverI - lowestCoverI);

		for (int i = 0; i < simulatedResults.size(); i++) {

			if (!simulatedResults.get(i).isMultipleILK) {
				tCoverI = simulatedResults.get(i).cOverI;
			} else {
				tCoverI = getCoverImultiple(scenario, i); // gets the lowest CoverI for that pixel
				i += numberOfInterferingLinks - 1;
			}

			Color colorAtIndex = getColor(tCoverI - lowestCoverI, range);
			if (getChckbxColorPattern().isSelected()) {
				if (tCoverI < this.rCoverI)
					StdDraw.setPenColor(StdDraw.RED);
				else
					StdDraw.setPenColor(StdDraw.LIGHT_GRAY);
			} else
				StdDraw.setPenColor(colorAtIndex);

			StdDraw.filledSquare(simulatedResults.get(i).x, simulatedResults.get(i).y, 0.06 * correctionFactor, false);
		}

		/** legend */
		drawScaling(lowestCoverI, highestCoverI, maxDistance, 20, " dB");
		StdDraw.setPenColor(StdDraw.BLACK);
		String headerText = "C/I distribution";
		headerText += (useUnwanted) ? " (unwanted)" : " (blocking)";
		StdDraw.text(0, 1.05 * maxDistance, headerText);
		StdDraw.setPenColor(StdDraw.MAGENTA);
		StdDraw.text(0.8 * maxDistance, -0.87 * maxDistance, " simulation radius " + df.format(simulationRadius)
				+ " km");
		StdDraw.setPenColor(StdDraw.BLACK);
		StdDraw.text(0.8 * maxDistance, -0.95 * maxDistance, (numberOfEventsToBeConsidered) + " events");

		if (numberOfInterferingLinks > 1) {
			StdDraw.text(0.8 * maxDistance, -1 * maxDistance, numberOfInterferingLinks + " interfering links");
		}
		StdDraw.show();
	}

	/**
	 * 
	 * @param scenario
	 * @param i
	 *            pixel to be checked
	 * @return lowest C/I of this pixel
	 */
	private double getCoverImultiple(ScenarioInfo scenario, int i) {
		double tCoverI = simulatedResults.get(i).cOverI;
		int j = 1; // selects the next link
		do {
			if (simulatedResults.get(i + j).cOverI < tCoverI) {
				tCoverI = simulatedResults.get(i + j).cOverI;
				j++;// selects the next link
			} else {
				j++;// selects the next link
			}
		} while (j < numberOfInterferingLinks);

		return tCoverI;
	}

	/**
	 * 
	 * @return highest CoverI
	 */
	private double getHighestCoverI() {
		double highest = -100;
		for (int i = 0; i < simulatedResults.size(); i++) {
			if (simulatedResults.get(i).cOverI > highest) {
				highest = simulatedResults.get(i).cOverI;
			}
		}
		return highest;
	}

	/**
	 * 
	 * @return lowest CoverI
	 */
	private double getLowestCoverI() {
		double lowest = 1000;
		for (int i = 0; i < simulatedResults.size(); i++) {
			if (simulatedResults.get(i).cOverI < lowest) {
				lowest = simulatedResults.get(i).cOverI;
			}
		}
		return lowest;
	}

	private void calculateCI() {
		// TODO Auto-generated method stub
		double rCoverI = 0;
		for (int i = 0; i < simulatedResults.size(); i++) {
			rCoverI = 10 * Math
					.log10(Math.pow(10, ((simulatedResults.get(i).dRSS) / 10))
							/ ((Math.pow(10, (((useUnwanted) ? simulatedResults.get(i).iRSS
									: simulatedResults.get(i).iRSSblock) / 10)))));
			simulatedResults.get(i).cOverI = rCoverI;
		}
	}

	protected void drawDistributionCIN() {
		// TODO Auto-generated method stub
		if(getRdbtnUnwanted().isSelected())useUnwanted = true;
		else useUnwanted = false;
		calculateCIN();
		drawCoverNplusI_Colored(scenario);
	}

	private void calculateCIN() {
		// TODO Auto-generated method stub
		double rCoverNplusI = 0;
		for (int i = 0; i < simulatedResults.size(); i++) {
			rCoverNplusI = 10 * Math
					.log10(Math.pow(10, ((simulatedResults.get(i).dRSS) / 10))
							/ ((Math.pow(10, (((useUnwanted) ? simulatedResults.get(i).iRSS
									: simulatedResults.get(i).iRSSblock) / 10)) + Math.pow(10,
									(simulatedResults.get(i).noiseFloor / 10)))));
			simulatedResults.get(i).cOverN = rCoverNplusI;
		}
	}

	/**
	 * {@literal shows a color scaled distribution of C/(N+I)}
	 * 
	 * @param scenario
	 */
	private void drawCoverNplusI_Colored(ScenarioInfo scenario) {
		getChckbxColorPattern().setEnabled(true);
		scaleFigure();
		double correctionFactor = getRadiusScaled() / 6.7 / 2;
		correctionFactor = 1;
		double lowestCoverN = getLowestCoverN();
		double highestCoverN = getHighestCoverN();
		double range = highestCoverN - lowestCoverN;
		double testCoverN = 0;

		for (int i = 0; i < simulatedResults.size(); i++) {
			testCoverN = simulatedResults.get(i).cOverN;
			if (simulatedResults.firstElement().isMultipleILK) {// more than one interfering link
				int j = 1;
				do {
					if (simulatedResults.get(i + j).cOverN < testCoverN) {
						testCoverN = simulatedResults.get(i + j).cOverN;
						j++;
					} else {
						j++;
					}
				} while (j < numberOfInterferingLinks);
				i += numberOfInterferingLinks - 1; // skips to the next pixel
			}
			Color colorAtIndex = getColor(testCoverN - lowestCoverN, range);
			if (getChckbxColorPattern().isSelected()) {
				if (testCoverN < this.rCoverIplusN)
					StdDraw.setPenColor(StdDraw.RED);
				else
					StdDraw.setPenColor(StdDraw.LIGHT_GRAY);
			} else
				StdDraw.setPenColor(colorAtIndex);
			StdDraw.filledSquare(simulatedResults.get(i).x, simulatedResults.get(i).y, 0.06 * correctionFactor, false);
		}

		/** legend */
		drawScaling(lowestCoverN, highestCoverN, maxDistance, rCoverIplusN, " dB");
		StdDraw.setPenColor(StdDraw.BLACK);
		String headerText = "C/(I+N) distribution";
		headerText += (useUnwanted) ? " (unwanted)" : " (blocking)";
		StdDraw.text(0, 1.05 * maxDistance, headerText);
		StdDraw.setPenColor(StdDraw.MAGENTA);
		StdDraw.text(0.8 * maxDistance, -0.87 * maxDistance, " simulation radius " + df.format(simulationRadius)
				+ " km");
		StdDraw.setPenColor(StdDraw.BLACK);
		StdDraw.text(0.8 * maxDistance, -0.95 * maxDistance, (numberOfEventsToBeConsidered) + " events");

		if (numberOfInterferingLinks > 1) {
			StdDraw.text(0.8 * maxDistance, -1 * maxDistance, numberOfInterferingLinks + " interfering links");
		}
		StdDraw.show();

	}

	/**
	 * 
	 * @return lowest CoverN
	 */
	private double getLowestCoverN() {
		double lowest = 100;
		for (int i = 0; i < simulatedResults.size(); i++) {
			if (simulatedResults.get(i).cOverN < lowest) {
				lowest = simulatedResults.get(i).cOverN;
			}
		}
		return lowest;
	}

	/**
	 * 
	 * @return highest CoverN
	 */
	private double getHighestCoverN() {
		double highest = -100;
		for (int i = 0; i < simulatedResults.size(); i++) {
			if (simulatedResults.get(i).cOverN > highest) {
				highest = simulatedResults.get(i).cOverN;
			}
		}
		return highest;
	}

	protected void drawDistributionDRSS() {
		// TODO Auto-generated method stub
		drawDRSS_Colored(scenario);
	}

	protected void drawLocationDRSS() {
		// TODO Auto-generated method stub
		setUseEBU(false);
		calculateLocationProbability(scenario); // to be sure that EBU is not used
		drawLocationProbability(scenario);
	}

	/**
	 * {@literal draws a colour scaled map of the dRSS distribution}
	 * 
	 * @param scenario
	 */
	private void drawDRSS_Colored(ScenarioInfo scenario) {
		scaleFigure();
		//		double getSimulationRadius();
		double correctionFactor = getRadiusScaled() / getSimulationRadius() / 2;
		correctionFactor = 1;
		double lowestDRSSS = getLowestDRSS();
		double highestDRSSS = getHighestDRSS();
		double range = highestDRSSS - lowestDRSSS;

		for (int i = 0; i < simulatedResults.size(); i++) {
			Color colorAtIndex = getColor(simulatedResults.get(i).dRSS - lowestDRSSS, range);
			StdDraw.setPenColor(colorAtIndex);
			StdDraw.filledSquare(simulatedResults.get(i).x, simulatedResults.get(i).y, 0.06 * correctionFactor, false); 
		}
		/** legend */
		drawScaling(getLowestDRSS(), getHighestDRSS(), maxDistance, -77.1, " dBm");
		StdDraw.setPenColor(StdDraw.BLACK);
		StdDraw.text(0, 1.05 * maxDistance, "dRSS distribution");
		StdDraw.setPenColor(StdDraw.MAGENTA);
		StdDraw.text(0.8 * maxDistance, -0.87 * maxDistance, " simulation radius " + df.format(simulationRadius)
				+ " km");
		StdDraw.setPenColor(StdDraw.BLACK);
		StdDraw.text(0.8 * maxDistance, -0.95 * maxDistance, (numberOfEventsToBeConsidered) + " events");
		StdDraw.show();

	}

	/**
	 * 
	 * @return lowest dRSS
	 */
	private double getLowestDRSS() {
		double lowest = 100;
		for (int i = 0; i < simulatedResults.size(); i++) {
			if (simulatedResults.get(i).dRSS < lowest) {
				lowest = simulatedResults.get(i).dRSS;
			}
		}
		return lowest;
	}

	/**
	 * 
	 * @return highest dRSS
	 */
	private double getHighestDRSS() {
		double highest = -100;
		for (int i = 0; i < simulatedResults.size(); i++) {
			if (simulatedResults.get(i).dRSS > highest) {
				highest = simulatedResults.get(i).dRSS;
			}
		}
		return highest;
	}

	protected void drawLocationEBU() {
		// TODO Auto-generated method stub
		setUseEBU(true);
		calculateLocationProbability(scenario); // to be sure that EBU is used
		drawLocationProbability(scenario);
	}

	private void drawLocationProbability(ScenarioInfo scenario) {
		// TODO Auto-generated method stub
		scaleFigure();
		double correctionFactor = getRadiusScaled() / simulationRadius / 2;
		correctionFactor = 1;
		double lowestLPnotZero = getLowestLPnotZero();
		double maxLP = getMaxLP();
		double range = maxLP - lowestLPnotZero;
		int j = -1; // increased to zero on the first step of the loop
		for (int i = 0; i < simulatedResults.size(); i++) {
			j++;
			double percentage = rLP.get(j).doubleValue();

			StdDraw.setPenColor(getColor(percentage - lowestLPnotZero, range));

			if (percentage < locationProbability && simulatedResults.get(i).iRSS > minDRSS && isUseEBU()) {
				//				StdDraw.setPenColor(StdDraw.RED);
			}

			StdDraw.filledSquare(simulatedResults.get(i).x, simulatedResults.get(i).y, 0.06 * correctionFactor, false);
			if (simulatedResults.firstElement().isMultipleILK) { // jumps to the next pixel
				i += numberOfInterferingLinks - 1;
			}
		}

		drawScaling(lowestLPnotZero, maxLP, maxDistance, locationProbability, "%");
		String assumedModelName = scenario.getVictimLink().getPropagationModel().getAssumedModel().name();
		if (propagationModel.length() > 2)
			assumedModelName = propagationModel;
		if (assumedModelName.equals("NoModelDefined")) {
			assumedModelName = "User-defined dRSS";
		} else if (propagationModel.length() > 2)
			assumedModelName = propagationModel;
		StdDraw.setPenColor(StdDraw.BLACK);
		if (!isUseEBU()) {
			double resultingLP = (double) (100 - (getNumberOfPixelsBelowLP()) / (double) (numberOfEventsToBeConsidered)
					* 100);
			StdDraw.text(0, 1.11 * maxDistance, "dRSS Location Propability distribution - " + assumedModelName);
			StdDraw.text(0, 1.05 * maxDistance, "Resulting Coverage Propability " + df.format(resultingLP) + "%");
		} else {
			double degradation = ((double) (getNumberOfPixelsNotMeetingLP() - getNumberOfPixelsBelowLP()) / (double) (numberOfEventsToBeConsidered - getNumberOfPixelsBelowLP())) * 100;
			if (degradation < 0)
				degradation = 0;
			StdDraw.text(0, 1.11 * maxDistance, "Location Propability distribution for "
					+ (df.format((double) (100 - (getNumberOfPixelsBelowLP()) / (double) (numberOfEventsToBeConsidered)
							* 100.0))) + "% coverage - " + assumedModelName);
			String textDegradation = "Location Propability degradation relative to " + locationProbability + "%  =  "
					+ df.format(degradation) + "%";
			textDegradation += (useUnwanted) ? " (unwanted)" : " (blocking)";
			StdDraw.text(0, 1.05 * maxDistance, textDegradation);
		}
		StdDraw.setPenColor(StdDraw.MAGENTA);
		StdDraw.text(0.8 * maxDistance, -0.87 * maxDistance, " simulation radius " + df.format(simulationRadius)
				+ " km");
		StdDraw.setPenColor(StdDraw.BLACK);
		StdDraw.text(0.8 * maxDistance, -0.92 * maxDistance, (numberOfEventsToBeConsidered) + " events");

		if (numberOfInterferingLinks > 1) {
			StdDraw.text(0.8 * maxDistance, -0.97 * maxDistance, numberOfInterferingLinks + " interfering links");
		}

		/*		if (isUseEBU()) {
					double degradation =
							((double) (getNumberOfPixelsNotMeetingLP() - getNumberOfPixelsBelowLP()) / (double) (getNumberOfEventsToBeConsidered())) * 100;
					StdDraw.text(-0.85 * maxDistance, -0.98 * maxDistance,
							"Location Probability degradation: " + df.format(degradation) + "%");
				}*/

		StdDraw.show();
	}

	/**
	 * 
	 * @return total number of pixels below required LP
	 */
	private int getNumberOfPixelsNotMeetingLP() {
		if (rLP == null)
			calculateLocationProbability(scenario);
		int k = 0;
		for (int i = 0; i < rLP.size(); i++) {
			if (rLP.get(i) < locationProbability) {
				k++;
			}
		}
		return k;
	}

	/**
	 * 
	 * @return highest value of location probability calculated
	 */
	private double getMaxLP() {
		double maxLP = 0;
		for (int i = 0; i < rLP.size(); i++) {
			if (rLP.get(i) > maxLP) {
				maxLP = rLP.get(i);
			}
		}
		return maxLP;
	}

	/**
	 * 
	 * @param lowest
	 * @param max
	 * @param distance
	 * @param reference
	 *            if zero: ignored
	 * @param s
	 *            = dimension of the parameter, e.g. % for probability
	 */
	private void drawScaling(double lowest, double max, double distance, double reference, String s) {
		Color rDot;
		double x0 = -0.95 * getRadiusScaled();
		double y0 = -1.08 * getRadiusScaled();
		double correctionFactor = getRadiusScaled() / 6.7; //  
		double y = 0.025 * correctionFactor;
		double x = 0.2 * correctionFactor;

		if ((getRdbtnCI_1().isSelected() || getRdbtnCIN_1().isSelected()) && getChckbxColorPattern().isSelected()
				&& getChckbxColorPattern().isEnabled()) {
			StdDraw.setPenColor(StdDraw.MAGENTA);
			double rRadius = getSimulationRadius();
			StdDraw.circle(0, 0, getSimulationRadius());
			StdDraw.setPenColor(StdDraw.DARK_GRAY);
			StdDraw.circle(0, 0, maxDistance);

		} else {
			for (int i = 0; i < 512; i++) {
				rDot = getColor(i, 512);
				StdDraw.setPenColor(rDot);
				StdDraw.line(x0 + i * y, y0, x0 + i * y, y0 + x, false);
			}

			StdDraw.setPenColor(new Color(0, 0, 255));
			StdDraw.text(1.15 * x0, y0, df.format(lowest) + s);
			StdDraw.setPenColor(new Color(0, 255, 0));
			StdDraw.text(x0 + 545 * y, y0, df.format(max) + s);
			if (reference != 0) {
				// FIX
				if (max == lowest) {
					if (max < reference)
						max = reference;
					else
						lowest = reference;
				}
				StdDraw.setPenColor(getColor((reference - lowest), (max - lowest)));
				StdDraw.text(x0 + 512 * (reference - lowest) / (max - lowest) * y, y0 + 2 * x, df.format(reference) + s);

				if (s.indexOf("%") != -1 && lowest < 50) {
					StdDraw.setPenColor(getColor((50 - lowest), (max - lowest)));
					StdDraw.text(x0 + 512 * (50 - lowest) / (max - lowest) * y, y0 + 2 * x, df.format(50) + s);
				}
			}

			StdDraw.setPenColor(StdDraw.MAGENTA);
			double rRadius = getSimulationRadius();
			StdDraw.circle(0, 0, getSimulationRadius());
			StdDraw.setPenColor(StdDraw.DARK_GRAY);
			StdDraw.circle(0, 0, maxDistance);
		}
		if(fileLoaded){
			StdDraw.setPenColor(StdDraw.LIGHT_GRAY);
			StdDraw.text(0, 1.16 * maxDistance, "File: " + getFileChooser().getSelectedFile().toString());
		}


	}

	/**
	 * 
	 * @param value
	 *            to be scaled
	 * @param range
	 *            of scaling
	 * @return corresponding colour red and blue combined 
	 */
	private Color getColor(double value, double range) {
		Color rColor = new Color(0, 0, 0);
		double i = ((value / range) * 511);
		if (value == 0 || value < 0)
			i = 0;
		if (i > 255) {
			return rColor = getColorGreen(i);
		}
		if (i <= 255) {
			if (value < 0) {
				rColor = new Color(255, 255, 255);
			} else {
				rColor = new Color((int) (i), 0, 255 - (int) (i));
			}
		}
		return rColor;
	}

	/**
	 * 
	 * @param value
	 *            to be scaled
	 * @return corresponding colour including green
	 */
	private Color getColorGreen(double value) {
		Color rColor;
		if (value > 511)
			value = 511;
		int i = (int) (value - 256);
		if (value < 0) {
			rColor = new Color(255, 255, 255);
		} else {
			rColor = new Color(255 - i, i, 0);
		}
		return rColor;
	}

	/**
	 * 
	 * @return lowest level not zero
	 */
	private double getLowestLPnotZero() {
		calculateLocationProbability(scenario);
		rLP = getLP();
		double[] tLP = new double[rLP.size()]; // leaves the order of the global rLP unchanged
		for (int i = 0; i < tLP.length; i++) {
			tLP[i] = rLP.get(i);
		}
		Arrays.sort(tLP);

		int i = -1; // increased by 1 entering the loop
		do {
			i++;
		} while (tLP[i] <= 0);
		double lowest = tLP[i];
		return lowest;
	}

	/**
	 * {@literal defines the size and scales the graph}
	 */
	private void scaleFigure() {
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		double screenWidth = dim.getWidth();
		double screenHeight = dim.getHeight();
		int figureSize = (int) Math.min(screenWidth, screenHeight) - 150;
		figureSize = Math.max(750, figureSize); // minimum size of 750 pixel
		//	figureSize = 650;
		StdDraw.setCanvasSize(figureSize, figureSize);
		double radius = Math.max(simulationRadius, maxDistance);
		//	if(maxDistance > (1.1*simulationRadius))radius = simulationRadius; // to avoid wrong scaling due to only a few positions
		setRadiusScaled(radius);
		StdDraw.setXscale((-1.2) * radius, 1.2 * radius);
		StdDraw.setYscale((-1.2) * radius, 1.2 * radius);
	}

	private void setRadiusScaled(double radius) {
		// TODO Auto-generated method stub
		radiusScaled = radius;
	}

	private double getRadiusScaled() {
		return this.radiusScaled;
	}

	private void calculateLocationProbability(ScenarioInfo scenario) {
		// TODO Auto-generated method stub
		rLP = new Vector<Double>();
		double testDRSS;
		double deltaFactor = 0;
		double percentage;
		double tCoverIplusN = 0;
		for (int i = 0; i < simulatedResults.size(); i++) {
			testDRSS = simulatedResults.get(i).dRSS;
			if (!simulatedResults.firstElement().isMultipleILK) {// single interfering link
				if (isUseEBU()) { // use the EBU approach considering C/(I+N)			
					double tIRSS = (useUnwanted) ? simulatedResults.get(i).iRSS : simulatedResults.get(i).iRSSblock;
					tCoverIplusN = 10 * Math.log10(Math.pow(10, (testDRSS / 10))
							/ (Math.pow(10, (tIRSS / 10)) + Math.pow(10, (simulatedResults.get(i).noiseFloor / 10))));

					deltaFactor = tCoverIplusN - rCoverIplusN;
				} else { // only dRSS
					deltaFactor = testDRSS - minDRSS;
				}
			} else {
				if (isUseEBU()) { // use the EBU approach considering C/(I+N)	
					tCoverIplusN = 10 * Math.log10(Math.pow(10, (testDRSS / 10))
							/ (Math.pow(10, (getSumOfInterfernce(i, scenario) / 10.)) + Math.pow(10, (simulatedResults
									.get(i).noiseFloor / 10))));
					deltaFactor = tCoverIplusN - rCoverIplusN;
				} else { // only dRSS
					deltaFactor = testDRSS - minDRSS;
				}
				i += numberOfInterferingLinks - 1; // jumps to the next pixel
			}

			deltaFactor /= STDDEV;

			percentage = getPercentageSevenTrials(deltaFactor); // iterative approach

			if (isUseEBU()) {
				if (tCoverIplusN <= 0)
					percentage = 0; // 
			} else {
				//	percentage = 100 - percentage; // as the location probability of the wanted signal
			}
			rLP.add(percentage);
		}
		setLP(rLP);
	}

	private void setLP(Vector<Double> rLP) {
		// TODO Auto-generated method stub
		this.rLP = rLP;
	}

	/**
	 * {@literal this method has been derived from a so called iterative approach}
	 * 
	 * @param deltaFactor2
	 * @return corresponding location probability
	 */
	private double getPercentageSevenTrials(double deltaFactor2) {

		double rPmid = 0;
		double rProbabilityFactor = 0;
		double rPmin = 0;
		double rPmax = 99.999;
		double erfcMax = 5;
		double erfcMin = 0;
		try {
			erfcMax = getLocationProbabilityFactor(rPmax);
		} catch (Exception e1) {
			e1.printStackTrace();
		}
		erfcMin = -erfcMax; // symmetrical
		try { // locationProbability is reference
			rProbabilityFactor = getLocationProbabilityFactor(locationProbability);
		} catch (Exception e1) {
			e1.printStackTrace();
		}
		double delta = deltaFactor2 + rProbabilityFactor;
		if (delta > erfcMax) {
			return rPmax; // limits the valid range
		} else if (delta < erfcMin) {
			return (100 - rPmax);
		} else {
			double erfc = 0;
			while (true) { // endless loop
				rPmid = (rPmax - rPmin) / 2 + rPmin;
				try {
					erfc = getLocationProbabilityFactor(rPmid);
				} catch (Exception e) {
					e.printStackTrace();
				}
				if (delta < 0)
					erfc *= -1;
				if (erfc < erfcMin)
					erfc = erfcMin;
				if (Math.abs(erfc - delta) < 0.001) {
					break; // leaves the loop
				} else {
					if (erfc < delta) {
						rPmin = rPmid;
					} else
						rPmax = rPmid;
				}
			}
			return rPmid;
		}
	}

	/**
	 * {@literal this method is taken from the propagation model P1546-3}
	 * 
	 * @param x
	 *            locationProbability
	 * @return correction factor
	 */
	private double getLocationProbabilityFactor(double x) throws Exception {
		double Q, t, xi;
		double c0, c1, c2, d1, d2, d3;
		x /= 100;
		try {
			if (x > 0.5) {
				x = 1 - x;
			}
			c0 = 2.515517;
			c1 = 0.802853;
			c2 = 0.010328;
			d1 = 1.432788;
			d2 = 0.189269;
			d3 = 0.001308;

			t = Math.sqrt((-2 * Math.log(x)));
			xi = (((c2 * t + c1) * t) + c0) / (((d3 * t + d2) * t + d1) * t + 1);
			if (x <= 0.5) {
				Q = t - xi;
			} else {
				Q = -(t - xi);
			}
			return Q;
		} catch (Exception e) {
			throw new Exception(e.getMessage());
		}
	}

	/**
	 * 
	 * @param i
	 *            actual pixel index
	 * @param scenario
	 * @return integrated iRSS
	 */
	private double getSumOfInterfernce(int i, ScenarioInfo scenario) {
		double sumOfInterference = 0;
		for (int j = 0; j < numberOfInterferingLinks; j++) {
			double testIRSS = (useUnwanted) ? simulatedResults.get(i + j).iRSS : simulatedResults.get(i + j).iRSSblock;
			sumOfInterference += Math.pow(10, ((useUnwanted) ? simulatedResults.get(i + j).iRSS : simulatedResults
					.get(i + j).iRSSblock) / 10);
		}
		double testSum = 10 * Math.log10(sumOfInterference);
		return 10 * Math.log10(sumOfInterference);
	}

	private Vector<Double> getLP() {
		// TODO Auto-generated method stub
		return rLP;
	}

	public void initPlugin() {
		// TODO Auto-generated method stub
		fileLoaded = false;
		/**
		 * forces the use of decimal point independent on the Locale and formats
		 * the output
		 */
		df = (DecimalFormat) DecimalFormat.getInstance(Locale.US);
		df.applyPattern("##0.0#");

		//simulatedResults = new Vector<CollectedDataUnwantedAndBlocking>(); // CollectedData of the data simulated
		if (getProgressBarLoad() != null)
			getProgressBarLoad().setVisible(false);
		setInitialized(true);

		scenario = getScenario();
		propagationModel = scenario.getVictimLink().getPropagationModel().getAssumedModel().name();
		if (propagationModel.equals("NoModelDefined"))
			propagationModel = "User-defined dRSS";
		simulationRadius = getSimulationRadius();
		rCoverI = scenario.getVictimLink().getReceiver().getRequiredCIRatio();
		rCoverIplusN = scenario.getVictimLink().getReceiver().getRequiredCNIRatio();
		rIoverN = scenario.getVictimLink().getReceiver().getRequiredINRatio();
		noiseFloor = simulatedResults.firstElement().noiseFloor;
		numberOfEventsToBeConsidered = scenario.getTotalNumberOfEvents() - scenario.getNumberOfInterferingLinks();
		numberOfInterferingLinks = scenario.getNumberOfInterferingLinks();
		numberOfPixelsBelowLP = getNumberOfPixelsBelowLP();
		//		System.out.println("initPlugin " + numberOfPixelsBelowLP);
		setParametToControlTab();
		getLblNewLabelFileName().setText("     ");
		getBtnApplyChanges().setVisible(false);
		getLblNewLabelFileName().setEnabled(false);
		getFrmSimulationResultsCollected().repaint();
		if (getChckbxDistributionOnly().isSelected()) {
			getRdbtnEBU_1().setEnabled(false);
			getRdbtnLocationDRSS_1().setEnabled(false);
			getRdbtnDrss_1().setSelected(true);
			getChckbxColorPattern().setEnabled(false);
			getFrmSimulationResultsCollected().repaint();
		} else {
			getRdbtnEBU_1().setSelected(true);
			getRdbtnEBU_1().setEnabled(true);
			getRdbtnLocationDRSS_1().setEnabled(true);
			getChckbxColorPattern().setEnabled(false);
			getFrmSimulationResultsCollected().repaint();
		}
	}

	/**
	 * @return the isNewFormat
	 */
	private boolean isNewFormat() {
		return isNewFormat;
	}

	private void setParametToControlTab() {
		// TODO Auto-generated method stub
		getTextFieldModel().setText(propagationModel);
		getTextFieldDistance().setText(Double.toString(simulationRadius));
		getTextFieldMinDRSS().setText(Double.toString(minDRSS));
		getTextFieldLP().setText(Double.toString(locationProbability));
		getTextFieldCI().setText(Double.toString(rCoverI));
		getTextFieldCIN().setText(Double.toString(rCoverIplusN));
		getTextFieldIN().setText(Double.toString(rIoverN));
		getTextFieldSTDDEV().setText(Double.toString(STDDEV));
		getTextFieldNoiseFloor().setText(Double.toString(noiseFloor));
	}

	/**
	 * @return the simulationRadius
	 */
	private double getSimulationRadius() {
		return simulationRadius;
	}

	private int getNumberOfPixelsBelowLP() {
		// TODO Auto-generated method stub
		int k = 0;
		if (!simulatedResults.firstElement().isMultipleILK) { // single interfering link
			for (int i = 0; i < simulatedResults.size(); i++) {
				if (simulatedResults.get(i).dRSS <= minDRSS) { // changed to <= instead of <
					k++;
				}
			}
		} else {
			for (int i = 0; i < simulatedResults.size(); i++) {
				if (simulatedResults.get(i).dRSS <= minDRSS) {// changed to <= instead of <
					k++;
					i += numberOfInterferingLinks - 1; // skips to next pixel
				}
			}
		}
		return k;
	}

	/**
	 * @return the resultMessageUnwanted
	 */
	public String getResultMessageUnwanted() {
		if (getProtectionCriterionUnwanted().indexOf("C/I") != -1)
			this.criterionIndex = 0;
		else if (getProtectionCriterionUnwanted().indexOf("C/(I+N)") != -1) {
			this.criterionIndex = 1;
			calculateLocationProbability(scenario);
		} else
			this.criterionIndex = 2;

		setNumberOfPixelsInterfered(scenario);
		String msg = "\n\n\nPixels not meeting min dRSS: \t\t" + getNumberOfPixelsBelowLP() + "\n";
		msg += "Pixels with interferer:  \t\t\t" + getNumberOfPixelsInterfered() + "\n";
		msg += "Number of pixels generated:  \t \t" + numberOfEventsToBeConsidered + " ("
				+ (df.format(numberOfEventsToBeConsidered / (maxDistance * maxDistance * Math.PI))) + "/sqkm)\n\n";
		msg += "Probability of exceeding the limit of " + getProtectionCriterionUnwanted() + " =\t\t"
				+ df.format(getCriterionLimit(criterionIndex)) + " dB \ndue to interference \t";
		if (useBlocking) {
			msg += "(blocking): \t\t";
		} else {
			msg += "(unwanted): \t\t";
		}
		msg += (df.format((double) ((getNumberOfPixelsInterfered())
				/ (double) (numberOfEventsToBeConsidered - getNumberOfPixelsBelowLP()) * 100.0)))
				+ "%\n";
		msg += "\nPercentage below minimum wanted Signal level: \t"
				+ (df.format((double) ((getNumberOfPixelsBelowLP()) / (double) (numberOfEventsToBeConsidered) * 100.0)))
				+ "%";
		if (isUseEBU() && criterionIndex == 1 && !getChckbxDistributionOnly().isSelected()) {// EBU and C(I+N
			double degradation = ((double) (getNumberOfPixelsNotMeetingLP() - getNumberOfPixelsBelowLP()) / (double) (numberOfEventsToBeConsidered - getNumberOfPixelsBelowLP())) * 100;
			if (degradation < 0)
				degradation = 0;
			msg += "\nDegradation of location probability of " + locationProbability + "%: \t\t"
					+ (df.format(degradation)) + "%";

		}
		return resultMessageUnwanted = msg;

	}

	/**
	 * @return the resultMessageBlocking
	 */
	public String getResultMessageBlocking() {
		if (getPotectionCriterionBlocking().indexOf("C/I") != -1)
			this.criterionIndex = 0;
		else if (getPotectionCriterionBlocking().indexOf("C/(I+N)") != -1) {
			this.criterionIndex = 1;
			calculateLocationProbability(scenario);
		} else
			this.criterionIndex = 2;
		setNumberOfPixelsInterfered(scenario);
		String msg = "\n\n\nPixels not meeting min dRSS: \t\t" + getNumberOfPixelsBelowLP() + "\n";
		msg += "Pixels with interferer:  \t\t\t" + getNumberOfPixelsInterfered() + "\n";
		msg += "Number of pixels generated:  \t \t" + numberOfEventsToBeConsidered + " ("
				+ (df.format(numberOfEventsToBeConsidered / (maxDistance * maxDistance * Math.PI))) + "/sqkm)\n\n";
		msg += "Probability of exceeding the limit of " + getPotectionCriterionBlocking() + " =\t\t"
				+ df.format(getCriterionLimit(criterionIndex)) + " dB \ndue to interference  ";
		if (useBlocking) {
			msg += "(blocking): \t\t\t";
			if(blockingResponse > 0)	msg += "\nconsidering " + df.format(blockingResponse) + " dB blocking response \t\t";
		} else {
			msg += "(unwanted): \t\t";
		}
		msg += (df.format((double) ((getNumberOfPixelsInterfered())
				/ (double) (numberOfEventsToBeConsidered - getNumberOfPixelsBelowLP()) * 100.0)))
				+ "%\n";
		msg += "\nPercentage below minimum wanted Signal level: \t"
				+ (df.format((double) ((getNumberOfPixelsBelowLP()) / (double) (numberOfEventsToBeConsidered) * 100.0)))
				+ "%";
		if (isUseEBU() && criterionIndex == 1 && !getChckbxDistributionOnly().isSelected()) {// EBU and C(I+N
			double degradation = ((double) (getNumberOfPixelsNotMeetingLP() - getNumberOfPixelsBelowLP()) / (double) (numberOfEventsToBeConsidered - getNumberOfPixelsBelowLP())) * 100;
			if (degradation < 0)
				degradation = 0;

			msg += "\nDegradation of location probability of " + locationProbability + "%: \t\t"
					+ (df.format(degradation)) + "%";

		}
		return resultMessageBlocking = msg;
	}

	private void drawFigures() {
		// TODO Auto-generated method stub
		if(getRdbtnEBU_1().isSelected() || getRdbtnLocationDRSS_1().isSelected() ){
			getChckbxDistributionOnly().setEnabled(false);
		}else{
			getChckbxDistributionOnly().setEnabled(true);
		}
		getFrmSimulationResultsCollected().repaint();
	}

	private void calculateBlocking(Component component) {
		// TODO Auto-generated method stub
		if (isInitialized()) {
			setRadioButtonBlocking();
			this.textPaneBlocking = (JTextPane) component.getComponentAt(607, 284); // any point within the JTextPane
			textPaneBlocking.setText(getResultMessageBlocking());
		}
	}

	private void calculateUnwanted(Component component) {
		// TODO Auto-generated method stub
		if (isInitialized()) {
			setRadioButtonUnwanted();
			this.textPaneUnwanted = (JTextPane) component.getComponentAt(607, 284); // any point within the JTextPane
			textPaneUnwanted.setText(getResultMessageUnwanted());
		}
	}

	/**
	 * {@literal initializes the parameter}
	 */
	private void prepareCalculation() {
		// TODO Auto-generated method stub

	}

	/**
	 * @return the useEBU
	 */
	public boolean isUseEBU() {
		return useEBU;
	}

	/**
	 * @param useEBU
	 *            the useEBU to set
	 */
	public void setUseEBU(boolean useEBU) {
		this.useEBU = useEBU;
	}

	public void setVisible() {
		// TODO Auto-generated method stub
		if (isInitialized())
			frmSimulationResultsCollected.setVisible(true);
	}

	/**
	 * @return the simulatedResults
	 */
	public Vector<CollectedDataUnwantedAndBlocking> getSimulatedResults() {
		return simulatedResults;
	}

	/**
	 * @param simulatedResults
	 *            the simulatedResults to set
	 */
	public void setSimulatedResults(Vector<CollectedDataUnwantedAndBlocking> simulatedResultsFromPost) {
		simulatedResults = new Vector<CollectedDataUnwantedAndBlocking>();
		simulatedResults = simulatedResultsFromPost;
	}

	/**
	 * @param maxDistance
	 *            the maxDistance to set
	 */
	public void setMaxDistance(double maxDistance) {
		this.maxDistance = maxDistance;
	}

	/**
	 * @return the scenario
	 */
	public ScenarioInfo getScenario() {
		return scenario;
	}

	/**
	 * @param scenario
	 *            the scenario to set
	 */
	public void setScenario(ScenarioInfo scenario) {
		this.scenario = scenario;
	}

	/**
	 * @param minDRSS
	 *            the minDRSS to set
	 */
	public void setMinDRSS(double minDRSS) {
		this.minDRSS = minDRSS;
	}

	/**
	 * @param sTDDEV
	 *            the sTDDEV to set
	 */
	public void setSTDDEV(double sTDDEV) {
		STDDEV = sTDDEV;
	}

	/**
	 * 
	 * @return
	 */
	private String getProtectionCriterionUnwanted() {
		if (comboBoxUnwanted == null)
			return null;
		switch (comboBoxUnwanted.getSelectedIndex()) {
			case 0:
				return "C/I";
			case 1:
				return "C/(I+N)";
			case 2:
				return "I/N";
			default:
				return "C/(I+N)";
		}

	}

	private String getPotectionCriterionBlocking() {
		if (comboBoxBlocking == null)
			return null;
		switch (comboBoxBlocking.getSelectedIndex()) {
			case 0:
				return "C/I";
			case 1:
				return "C/(I+N)";
			case 2:
				return "I/N";
			default:
				return "C/(I+N)";
		}
	}

	public void setLocationProbability(double locationProbability) {
		// TODO Auto-generated method stub
		this.locationProbability = locationProbability;
	}

	/**
	 * @param numberOfPixelsInterfered
	 *            the numberOfPixelsInterfered to set
	 * @param scenario
	 */
	private void setNumberOfPixelsInterfered(ScenarioInfo scenario) {
		this.numberOfPixelsInterfered = getNumberOfPixelsInterfered(scenario);
	}

	/**
	 * 
	 * @param scenario
	 * @return number of pixels not meeting the limit
	 */
	private int getNumberOfPixelsInterfered(ScenarioInfo scenario) {
		int k = 0;

		for (int i = 0; i < simulatedResults.size(); i++) {
			simulatedResults.get(i).isInterfered = false;
			if (!simulatedResults.firstElement().isMultipleILK) {// single interfering link
				if (getLimitExceeded(i)) {
					simulatedResults.get(i).isInterfered = true;
					k++;
				}
			} else {// more than one interfering link
				if (getLimitExceededMultiple(i, scenario)) {
					simulatedResults.get(i).isInterfered = true;
					k++;
				}
				i += numberOfInterferingLinks - 1; // jumps to next pixel
			}
		}
		return k;
	}

	/**
	 * 
	 * @param i
	 *            index of current location
	 * @return protection criterion exceeded or not
	 */
	private boolean getLimitExceeded(int i) {
		boolean isInterfered = false;
		switch (criterionIndex) {
			case 0: { // C/I
				if (simulatedResults.get(i).dRSS < ((useUnwanted) ? simulatedResults.get(i).iRSS : simulatedResults
						.get(i).iRSSblock
						+ rCoverI)
						&& simulatedResults.get(i).dRSS > minDRSS) {
					simulatedResults.get(i).isInterfered = true;
					isInterfered = true; // exceeded
				}
				break;
			}
			case 1: {// C/(I+N)
				if (simulatedResults.get(i).dRSS < ((useUnwanted) ? simulatedResults.get(i).iRSS : simulatedResults
						.get(i).iRSSblock
						+ rCoverIplusN)
						&& simulatedResults.get(i).dRSS > minDRSS) {
					simulatedResults.get(i).isInterfered = true;
					isInterfered = true; // exceeded
				}
				break;
			}
			case 2: {// I/N
				double interferingLevel = (useUnwanted) ? simulatedResults.get(i).iRSS
						: simulatedResults.get(i).iRSSblock;

				if (interferingLevel >= (simulatedResults.get(i).noiseFloor + rIoverN)
						&& simulatedResults.get(i).dRSS > minDRSS) {
					simulatedResults.get(i).isInterfered = true;
					isInterfered = true; // exceeded
				}
				break;
			}
			default:
				isInterfered = false;

		}
		return isInterfered;
	}

	private boolean getLimitExceededMultiple(int i, ScenarioInfo scenario) {
		// TODO Auto-generated method stub
		double sumOfInterference = getSumOfInterfernce(i, scenario);
		if (getLimitExceeded(i, sumOfInterference)) {
			simulatedResults.get(i).isInterfered = true;
			return true;
		} else {
			simulatedResults.get(i).isInterfered = false;
			return false;
		}
	}

	private boolean getLimitExceeded(int i, double sum) {
		boolean isInterfered = false;
		switch (criterionIndex) {
			case 0: { // C/I
				if (simulatedResults.get(i).dRSS < (sum + rCoverI) && simulatedResults.get(i).dRSS > minDRSS) {
					simulatedResults.get(i).isInterfered = true;
					isInterfered = true; // exceeded
				}
				break;
			}
			case 1: {// C/(I+N)
				double includeNoise = 10 * Math.log10(Math.pow(10, (sum / 10))
						+ Math.pow(10, (simulatedResults.get(i).noiseFloor / 10)));
				if (simulatedResults.get(i).dRSS < (includeNoise + rCoverIplusN)
						&& simulatedResults.get(i).dRSS > minDRSS) {
					simulatedResults.get(i).isInterfered = true;
					isInterfered = true; // exceeded
				}
				break;
			}
			case 2: {// I/N
				if (sum >= (simulatedResults.get(i).noiseFloor + rIoverN) && simulatedResults.get(i).dRSS > minDRSS) {
					simulatedResults.get(i).isInterfered = true;
					isInterfered = true; // exceeded
				}
				break;
			}
			default:
				isInterfered = false;

		}
		return isInterfered;
	}

	/**
	 * @return the numberOfPixelsInterfered
	 */
	private int getNumberOfPixelsInterfered() {
		return numberOfPixelsInterfered;
	}

	/**
	 * 
	 * @param criterionIndex
	 * @return protection criterion to be used for calculation
	 */
	private double getCriterionLimit(int criterionIndex) {
		switch (criterionIndex) {
			case 0:
				return rCoverI;
			case 1:
				return rCoverIplusN;
			case 2:
				return rIoverN;
			default:
				return (rCoverIplusN);
		}
	}

	public void setSimulationRadius(double simulationRadius) {
		this.simulationRadius = simulationRadius;
	}

	public JFileChooser getFileChooser() {
		return fileChooser;
	}

	public JProgressBar getProgressBarLoad() {
		return progressBarLoad;
	}

	public JTabbedPane getTabbedPane() {
		return tabbedPane_1;
	}

	public JPanel getJp_control() {
		return jp_control;
	}

	public JTextField getTextFieldModel() {
		return textFieldModel;
	}

	public JTextField getTextFieldDistance() {
		return textFieldDistance;
	}

	public JTextField getTextFieldMinDRSS() {
		return textFieldMinDRSS;
	}

	public JTextField getTextFieldCI() {
		return textFieldCI;
	}

	public JTextField getTextFieldCIN() {
		return textFieldCIN;
	}

	public JTextField getTextFieldIN() {
		return textFieldIN;
	}

	public JTextField getTextFieldSTDDEV() {
		return textFieldSTDDEV;
	}

	public JTextField getTextFieldLP() {
		return textFieldLP;
	}

	public JFrame getFrmSimulationResultsCollected() {
		return frmSimulationResultsCollected;
	}

	public void closeBridgeToPost() {
		getFrmSimulationResultsCollected().dispose();
	}

	public JLabel getLblNewLabelFileName() {
		return lblNewLabelFileName;
	}

	public JRadioButton getRdbtnEBU_1() {
		return rdbtnEBU_1;
	}

	public JButton getBtnApplyChanges() {
		return btnApplyChanges;
	}

	public JCheckBox getChckbxDistributionOnly() {
		return chckbxDistributionOnly;
	}

	public JRadioButton getRdbtnLocationDRSS_1() {
		return rdbtnLocationDRSS_1;
	}

	public JRadioButton getRdbtnDrss_1() {
		return rdbtnDrss_1;
	}

	public JCheckBox getChckbxColorPattern() {
		return chckbxColorPattern;
	}
	public JPanel getPanelNotDRSS() {
		return panelNotDRSS;
	}
	public JPanel getJp_draw() {
		return jp_draw;
	}
	public JRadioButton getRdbtnCI_1() {
		return rdbtnCI_1;
	}
	public JRadioButton getRdbtnUnwanted() {
		return rdbtnUnwanted;
	}
	public JRadioButton getRdbtnCIN_1() {
		return rdbtnCIN_1;
	}
	public JTextField getTextFieldNoiseFloor() {
		return textFieldNoiseFloor;
	}

	public void setBlockingResponse(double blockingResponse) {
		// TODO Auto-generated method stub
		this.blockingResponse = blockingResponse;
	}
}

/*-------------------------------------*/

class CollectedDataUnwantedAndBlocking {
	int event;
	double x;
	double y;
	double dRSS;
	double iRSS;
	double iRSSblock;
	int ilk;
	double cOverN;
	double cOverI;
	double cIverN;
	double noiseFloor;
	boolean isMultipleILK;
	boolean isInterfered;
	double minDRSS;
	double STDDEV;
	double simulationRadius;
	double blockingResponse;
	String propagationModel;
}

class ProgressBarStoreFile {
	JProgressBar progressBar;
	JFrame frame;

	public ProgressBarStoreFile(String label) {
		this.frame = new JFrame(label);
		this.progressBar = new JProgressBar(0, 100);
	}

	public void init() {
		int width = 400;
		int height = 50;
		progressBar.setStringPainted(true);
		progressBar.setForeground(new Color(200, 200, 50));
		frame.setSize(width, height);
		frame.setLocationRelativeTo(null);
		frame.setResizable(false);
		frame.getContentPane().add(progressBar);
		frame.setVisible(true);
	}

	public void stop() {
		frame.dispose();
		frame.setVisible(false);
	}
}
